﻿/**
"Инвестиционная" стратегия. 
При старте продает по текущим ценам начальный объем qStart. 
Допродает на Q при росте цены, не более позиции робота и не выше порога (cmax).
Покупает допроданное кол-во при падении цены ниже цены начальной продажи.
Если Poor не равен 0, допродажи закрываются частями по цене ниже чем последняя цена на дельту.
Покупает весь объем при падении цены ниже целевой цены и останавливается
Algorithm = ИНВЕСТИЦИИ;**/

function Initialize()
{

   StrategyName = "Invest_negative";
   AddParameter("qStart", 1000, "Сколько продать при старте", 0);
   AddParameter("cmin", 140, "Целевая цена", 0);
   AddParameter("cmax", 180, "Верхний порог покупки", 0);
   AddParameter("Q", 10, "Шаг продажи в штуках", 0);
   AddParameter("Poor", 0, "Закрывать допродажи частями, если значение не 0", 0);

   AddInput("Input1", Inputs.Candle, 1, true, "");

   AddGlobalVariable("LastPrice", Types.Double, 100000000000);
   AddGlobalVariable("FirstPrice", Types.Double, 0);
   AddGlobalVariable("DeltaPrice", Types.Double, 0);

}

function OnUpdate()
{
// В момент запуска продаем qStart 
// Основная прибыль: покупаем qStart по цели (cmin)
// Дополнительна: выше цены старта продаем (но не выше cmax), ниже покупаем 

double c = Input1.Close[0];
double pos = CurrentPosition();
double qStep;

// Правило 1: Открытие позиции на начальный объем 
// и расчет DeltaPrice
   if ( (LastPrice == 100000000000) )
   {   
       // Проверки
      if (Q <= 0)
      {
              ShowMessage("Не задано Q - шаг количества");
              Stop();
      }
      if ( cmin >= cmax ) 
      {
              ShowMessage("cmin больше, чем cmax ");
              Stop();
      }
   
       // Открываем позицию, если стартовое кол-во больше 0
       if (qStart > 0)
         EnterShort(qStart);
        LastPrice =  c;
        FirstPrice =  c;
      // Расчитываем дельту цены для докупки
      if (Q > 0 )
      { 
         qStep = (Math.Abs(ShortLimit) - qStart) / Q ;
         DeltaPrice = (cmax - LastPrice) / qStep;
      }
   }
   
// Правило 2: Закрытие всей позиции при достижении сmin
   if ( c < cmin)
    {
       CloseShort();
       ShowMessage("Цена достигла цели, робот закрывает позицию и будет остановлен");
       Stop();
       // Остановка робота
     }
     
// Правило 3: Добавление к позиции при росте 
   if ( c > LastPrice + DeltaPrice && c < cmax )
   {
      EnterShort(Q);
      LastPrice =  c;
     }
// Правило 4: Закрытие допроданной части позиции при падении ниже цены стартовой продажи
   if ( c < FirstPrice && -pos > qStart)
    {
       CloseShort(-pos - qStart);
       LastPrice =  c;
     }
     
// Правило 5: Закрытие допроданной части позиции при падении ниже последней цены на deltaPrice
   if ( Poor != 0 && c < LastPrice - DeltaPrice && -pos > qStart)
    {
       CloseShort(Q);
       LastPrice =  c;
     }
     

}

